package com.casic.dcms.mvp.model.impl;

import com.casic.dcms.bean.ActionResultBean;
import com.casic.dcms.listener.OnActionResultListener;
import com.casic.dcms.mvp.model.IChangeShopInfoModel;
import com.casic.dcms.utils.retrofit.RetrofitServiceManager;

import rx.Observable;
import rx.Observer;
import rx.Subscription;
import rx.android.schedulers.AndroidSchedulers;
import rx.schedulers.Schedulers;

public class ChangeShopInfoModelImpl implements IChangeShopInfoModel {

    private final OnActionResultListener actionResultListener;

    public ChangeShopInfoModelImpl(OnActionResultListener listener) {
        this.actionResultListener = listener;
    }

    /**
     * {@link com.casic.dcms.mvp.model.IChangeShopInfoModel}
     */
    @Override
    public Subscription sendChangeShopInfoRequest(String merchantId, String merchantName, String contactName, String contactPhone, String images) {
        Observable<ActionResultBean> observable = RetrofitServiceManager.getShopChangeResult(merchantId,
                merchantName, contactName, contactPhone, images);
        return observable.subscribeOn(Schedulers.io()).observeOn(AndroidSchedulers.mainThread()).subscribe(new Observer<ActionResultBean>() {
            @Override
            public void onCompleted() {

            }

            @Override
            public void onError(Throwable e) {
                if (e.getCause() != null) {
                    actionResultListener.onFailure(e);
                }
            }

            @Override
            public void onNext(ActionResultBean resultBean) {
                if (resultBean != null) {
                    actionResultListener.onSuccess(resultBean);
                }
            }
        });
    }

}
